// RealTimeDialogDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RealTimeDialog.h"
#include "RealTimeDialogDlg.h"
#include "..\header\RealTimeTimer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CRealTimeDialogDlg*	pMyDialog;
CButton*			pButtonActivity;

/////////////////////////////////////////////////////////////////////////////
// CRealTimeDialogDlg _CAO

CRealTimeDialogDlg::CRealTimeDialogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRealTimeDialogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRealTimeDialogDlg)
	m_Frequency = 1000;
	m_Period = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	IsRunning = FALSE;
}

void CRealTimeDialogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRealTimeDialogDlg)
	DDX_Control(pDX, ID_BUTTON_COMMANDPROMPT, m_B_CommandPrompt);
	DDX_Control(pDX, IDCANCEL, m_B_Cancel);
	DDX_Control(pDX, IDC_B_START, m_B_Start);
	DDX_Text(pDX, IDC_FREQUENCY, m_Frequency);
	DDV_MinMaxDWord(pDX, m_Frequency, 1, 100000000);
	DDX_Text(pDX, IDC_PERIOD, m_Period);
	DDV_MaxChars(pDX, m_Period, 100);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRealTimeDialogDlg, CDialog)
	//{{AFX_MSG_MAP(CRealTimeDialogDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_B_START, OnStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ACTIVITY, OnActivity)
	ON_BN_CLICKED(ID_BUTTON_COMMANDPROMPT, OnButtonCommandprompt)
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRealTimeDialogDlg bZ[W nh

BOOL CRealTimeDialogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	HANDLE hMyThread = GetCurrentThread();
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ


	MaxRecordNum = 100;
	pRecord = new double[MaxRecordNum];
	recordNum= 0;
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	SetThreadPriority(hMyThread,THREAD_PRIORITY_ABOVE_NORMAL);  //\pXbh(̃_CAÕXbh)̗D揇ʂŒᣂɐݒ
	pMyDialog = this;
	pButtonActivity = (CButton*)GetDlgItem(IDC_ACTIVITY);
	pEditFrequency = (CEdit*)GetDlgItem(IDC_FREQUENCY);
	SendMessage(WM_SYSCOMMAND,SC_MAXIMIZE,0);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CRealTimeDialogDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CRealTimeDialogDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRealTimeDialogDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
//	CDialog::OnOK();
}

void CRealTimeDialogDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	EndRealTimeTimer();

//	MessageBox("OnCancel","OnCancel",MB_OK);
//	Sleep(2000);

	MaxRecordNum = 0;
	//delete pRecord;
	CDialog::OnCancel();
//	ExitWindowsEx(EWX_LOGOFF,0);

}


////////////////////////////////////////////////////////////////////////////
//Start/Stop {^ꂽƂ̏
void CRealTimeDialogDlg::OnStart() 
{
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	if(IsRunning)
	{
		/////////////////////////////////////////////////////////////
		//A^Cs
		EndRealTimeTimer();
		KillTimer(1);
		IsRunning = FALSE;
//		SendMessage(WM_SYSCOMMAND,SC_RESTORE,0);
		m_B_Cancel.ModifyStyle(WS_DISABLED,0,0);
		m_B_Start.SetWindowText("Start");
		m_B_CommandPrompt.ModifyStyle(WS_DISABLED,0,0);
		pButtonActivity->SetCheck(0);
		pButtonActivity->Invalidate(FALSE);
		pButtonActivity->UpdateWindow();
		pEditFrequency->SetReadOnly(FALSE);
		Invalidate(FALSE);
		UpdateWindow();
	}
	else
	{
		/////////////////////////////////////////////////////////////
		//A^C~
//		SendMessage(WM_SYSCOMMAND,SC_MAXIMIZE,0);
		pEditFrequency->SetReadOnly(TRUE);
		UpdateData(TRUE);
		Count = 0;
		pButtonActivity->SetCheck(1);
		m_B_Start.SetWindowText("Stop");
		m_B_Cancel.ModifyStyle(0,WS_DISABLED,0);
		m_B_CommandPrompt.ModifyStyle(0,WS_DISABLED,0);
		IsRunning = TRUE;
		Invalidate(FALSE);
		UpdateWindow();
		SetTimer(1,500,NULL);	
		SetRealTimeTimer(m_Frequency);
		StartTimer();
	}

}

void CRealTimeDialogDlg::OnTimer(UINT nIDEvent) 
{
	/////////////////////////////////////////////////////////////////
	//A^Cs̕\XVp^C}[荞(񃊃A^C300[msec])
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	int i;
	double DifferenceMean=0;
	double DifferenceMax=Difference;
	double DifferenceMin=Difference;

	for( i= 0; i<MaxRecordNum;i++)
	{
		if( DifferenceMax < pRecord[i] ) DifferenceMax = pRecord[i];
		if( DifferenceMin > pRecord[i] ) DifferenceMin = pRecord[i];
		DifferenceMean += pRecord[i];
	}
	DifferenceMean = DifferenceMean/MaxRecordNum;


	m_Period.Format("%13.6f (Mean: %8.3f/Max:%8.3f/Min:%8.3f)",Difference*1000.0, DifferenceMean*1000, (DifferenceMax-DifferenceMean)*1000.0, (DifferenceMin-DifferenceMean)*1000.0);
	UpdateData(FALSE);
	UpdateWindow();
//	CDialog::OnTimer(nIDEvent);
}


/////////////////////////////////////////////////////////////
//A^C(Example)
//1.0[sec]Ƃ  Activity  _ł
void  IntervalTask()
{

	(pMyDialog->Count)++;
	if(pMyDialog->Count > pMyDialog->m_Frequency/2)
	{
		//MessageBeep(0xFFFFFFFF);
		//Beep(0x4000,1);
		pButtonActivity->SetCheck( 1-pButtonActivity->GetCheck() );
		pButtonActivity->Invalidate(FALSE);
		pButtonActivity->UpdateWindow();
		pMyDialog->Count = 1;
	}

	if(pMyDialog->MaxRecordNum >0)
	{
		pMyDialog->pRecord[pMyDialog->recordNum] = Difference;
		pMyDialog->recordNum ++;
		if(pMyDialog->recordNum > pMyDialog->MaxRecordNum) pMyDialog->recordNum = 0;
	}


	return;
};

void CRealTimeDialogDlg::OnActivity() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		pButtonActivity->SetCheck( 1-pButtonActivity->GetCheck() );
}



void CRealTimeDialogDlg::OnButtonCommandprompt() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char pSysDir[256];
	CString ModuleName;
	STARTUPINFO StartUpInfo;
	PROCESS_INFORMATION ProcessInfo;
	
	GetWindowsDirectory(pSysDir,255);
	ModuleName.Format("%s\\explorer.exe",pSysDir);
	
//	MessageBox(ModuleName,"Info",MB_OK);
	GetStartupInfo(&StartUpInfo);
	if(CreateProcess(ModuleName,
		              NULL,
					  NULL,
					  NULL,
					  TRUE,
					  CREATE_DEFAULT_ERROR_MODE|NORMAL_PRIORITY_CLASS,
					  NULL,
					  pSysDir,
					  &StartUpInfo,
					  &ProcessInfo)==0)
	{

		LPVOID lpMsgBuf;

		FormatMessage(	FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					    FORMAT_MESSAGE_FROM_SYSTEM | 
					    FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						GetLastError(),
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
						(LPTSTR) &lpMsgBuf,
						0,
						NULL );

		//ŕKvɉ lpMsgBuf Ɋւ鏈s
		// ...
		MessageBox((const char*)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		LocalFree( lpMsgBuf );
	}
	
}


void CRealTimeDialogDlg::OnDestroy() 
{
	//MessageBox("OnDestroy()","OnDestroy",MB_OK);
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
}
